<?php 
/*
// "K2 Tools" Module by JoomlaWorks for Joomla! 1.5.x - Version 2.1
// Copyright (c) 2006 - 2009 JoomlaWorks Ltd. All rights reserved.
// Released under the GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
// More info at http://www.joomlaworks.gr and http://k2.joomlaworks.gr
// Designed and developed by the JoomlaWorks team
// *** Last update: September 9th, 2009 ***
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');

class modK2CategoriesHelper {
  
  function hasChildren($id) {
  
    $user = &JFactory::getUser();
    $aid = $user->get('aid');
    $db = &JFactory::getDBO();
    $query = "SELECT * FROM #__k2_categories  WHERE parent={$id} AND published=1 AND trash=0 AND access<={$aid} ";
    $db->setQuery($query);
    $rows = $db->loadObjectList();
    if ($db->getErrorNum()) {
      echo $db->stderr();
      return false;
    }
    
    if (count($rows)) {
      return true;
    } else {
      return false;
    }
  }
  
  
  function treerecurse_sc(&$params, $id = 0, $level = 0, $begin = false) 
  {
    
    $root_id = $params->get('root_id_sc');
    $end_level = $params->get('end_level_sc', NULL);
    
    $catid = JRequest::getInt('id');
    $option = JRequest::getCmd('option');
    $view = JRequest::getCmd('view');
    
    $user = &JFactory::getUser();
    $aid = $user->get('aid');
    $db = &JFactory::getDBO();
    
    switch ($params->get('categoriesListOrdering_sc')) {
    
      case 'alpha':
        $orderby = 'name';
        break;
        
      case 'ralpha':
        $orderby = 'name DESC';
        break;
        
      case 'order':
        $orderby = 'ordering';
        break;
        
      case 'reversedefault':
        $orderby = 'id DESC';
        break;
        
      default:
        $orderby = 'id ASC';
        break;
    }
    
    if (($root_id != 0) && ($level == 0)) {
      $query = "SELECT * FROM #__k2_categories WHERE parent={$root_id} AND published=1 AND trash=0 AND access<={$aid} ORDER BY {$orderby}";
      
    } else {
      $query = "SELECT * FROM #__k2_categories WHERE parent={$id} AND published=1 AND trash=0 AND access<={$aid} ORDER BY {$orderby}";
    }
    
    $db->setQuery($query);
    $rows = $db->loadObjectList();
    if ($db->getErrorNum()) {
      echo $db->stderr();
      return false;
    }
    
	if ($level < intval($end_level) || is_null($end_level)) {
    	$categories = array() ;
		foreach ($rows as $row) {
		
	        if (modK2CategoriesHelper::hasChildren($row->id)) {
	          	$children = modK2CategoriesHelper::treerecurse_sc($params, $row->id, $level + 1);
	        } else {
	        	$children = "" ;
	        }

	  		$categories[] = array("id" => $row->id, 
	  								"name" => $row->name, 
	  								"image" => JURI::root().'media/k2/categories/'.$row->image, 
	  								"url" => urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($row->id.':'.urlencode($row->alias)))),
	  								"num_of_item" => modK2CategoriesHelper::countCategoryItems($row->id),
	  								"active" => (($option == 'com_k2') && ($view == 'itemlist') && ($catid == $row->id)),
	  								"children" => $children);
			
      }
    }
    return $categories;
  }

  
  function countCategoryItems($id) {
  
    $user = &JFactory::getUser();
    $aid = $user->get('aid');
    $db = &JFactory::getDBO();
    
    $jnow = &JFactory::getDate();
    $now = $jnow->toMySQL();
    $nullDate = $db->getNullDate();
    
    $query = "SELECT COUNT(*) FROM #__k2_items WHERE catid={$id} AND published=1 AND ( publish_up = ".$db->Quote($nullDate)." OR publish_up <= ".$db->Quote($now)." ) AND ( publish_down = ".$db->Quote($nullDate)." OR publish_down >= ".$db->Quote($now)." ) AND trash=0 AND access<={$aid}";
    $db->setQuery($query);
    $total = $db->loadResult();
    return $total;
  }
    
}
